.386
.model flat,stdcall
option casemap:none

Include		\masm32\include\windows.inc
Include		ColorDlg.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\gdi32.lib

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

EXTERN		ColorDlg:PTR BYTE

OFFSET_Menu	= 0A0h ; Offset value reported by Res2obj

.data
msg			db 'Resource in static library',0
title1		db 'About',0

.data?
hBrush		dd ?

IDM_ABOUT	equ 11
IDM_EXIT	equ 12
IDC_ABOUT	equ 110
IDC_EXIT	equ 120
IDC_EDIT	equ 3000

.code

start:

	invoke	GetModuleHandle,NULL
	invoke	DialogBoxIndirectParam,eax,ADDR ColorDlg,NULL,ADDR DlgProc,NULL
	invoke	ExitProcess,eax

DlgProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
		.IF uMsg==WM_INITDIALOG
			invoke	LoadIcon,NULL,IDI_APPLICATION	
			invoke	SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
			lea		eax,[ColorDlg+OFFSET_Menu]
			invoke	LoadMenuIndirect,eax
			invoke	SetMenu,hWnd,eax
        
        .ELSEIF uMsg==WM_CTLCOLORDLG
            invoke	CreateSolidBrush,Blue
            mov		hBrush,eax
            ret

        .ELSEIF uMsg==WM_CLOSE
            invoke	SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

        .ELSEIF uMsg==WM_COMMAND
			mov	eax,wParam
		
			.IF lParam==0
				.IF ax==IDM_ABOUT
					invoke	MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                        
				.ELSEIF ax==IDM_EXIT
				@@:
				invoke	DeleteObject,hBrush
				invoke	EndDialog, hWnd,NULL
				.ENDIF
			.ELSE
			mov	edx,wParam
			shr	edx,16
				.IF dx==BN_CLICKED
                                
					.IF ax==IDC_ABOUT
						invoke	SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                        	
					.ELSEIF ax==IDC_EXIT
					jmp @b
					.ENDIF
				.ENDIF
			.ENDIF
		.ELSE
		mov	eax,FALSE
		ret
		.ENDIF
	mov eax,TRUE
	ret

DlgProc	ENDP
END		start